package com.coob.aframe.filter;

import java.io.IOException;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.filter.OncePerRequestFilter;

import com.coob.aframe.base.Application;

public class CooBFilter extends OncePerRequestFilter {

	@Override
	protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)
			throws ServletException, IOException {
		
		String strUri = request.getRequestURI() ;
		boolean flag = true;	//是否验证登录
		
		if( strUri.equals(Application.contextPath) ){
			flag = false;	//允许未登录访问
		} else {
			String[] freeUrl = Application.freeUrl;
			if( freeUrl != null && freeUrl.length > 0){
				for( String u : freeUrl ){
					if( u.length()> 0 ){
						if( strUri.indexOf(u) > -1 ){
							flag = false;
							break;
						}
					}
				}
			}
		}
			
		if( flag ){
			if( request.getSession().getAttribute(Application.SESSION_USER_INFO) == null ){
				response.sendRedirect(Application.contextPath+"timeout.jsp");
				return;
			} 
		}
		
		filterChain.doFilter(request, response);		//不执行过滤,继续执行操作  
		return ;  
	}
}