package com.coob.modules.api;

import com.coob.aframe.base.R;
import com.coob.modules.api.vo.LabelValueVo;
import com.coob.modules.tg.domain.Xmxx;
import com.coob.modules.tg.service.XmxxService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 微信端，团购信息Api
 * 查询团购活动、楼盘信息
 */
@Controller
@RequestMapping("/api/tg/area")
public class AreaApi extends BaseApi {
    @Resource
    private XmxxService xmxxService;


    /**
     * 查询正所有区县信息
     *
     * @param key
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/list", method = {RequestMethod.POST, RequestMethod.GET}, produces = "application/json;charset=utf8")
    public R list(String key, Integer hdid) {
        boolean flag = this.checkKey(key);
        if (!flag) {
            return R.error(505, "数据请求异常");
        }

        if (hdid == null || hdid == 0) {
            return R.error(503, "业务请求异常");
        }
        // 根据团购信息获取 本团购信息项目
        Map<String, Object> params = new HashMap<>();
        params.put("tgid", hdid);
        List<Xmxx> result = this.xmxxService.selectListByTgidForWx(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(result);
        List<Xmxx> xmList = pageInfo.getList();
        // 获取 项目项目的区域
        Map<Integer, LabelValueVo> map = new HashMap<>();
        for (Xmxx xm : xmList) {
            LabelValueVo vo = map.get(xm.getQx());
            if (vo == null) {
                vo = new LabelValueVo(xm.getQx(), xm.getQxmc());
                map.put(xm.getQx(), vo);
            }
        }
        List<LabelValueVo> voList = new ArrayList<>();
        voList.add(new LabelValueVo(0, "潍坊市"));
        voList.addAll(map.values());
        return R.ok(200, "ok").put("size", voList.size()).put("list", voList);
    }

}
