package com.coob.modules.api.vo;

import com.coob.modules.tg.domain.Tgxx;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 报名人员类别信息
 */
@Data
public class RylbVo implements Serializable {
    private static final long serialVersionUID = -1L;

    private Integer hdid;       //活动ID
    private Integer xmid;       //项目ID
    private Integer lbbs;       //类别标识 0不用选择类别  1选择
    private List<Map<String, String>> lbmcs;     //类别名称列表
    private Integer zjbs;       //证件标识 0不用填写证件号 1需要填写
    private String zjmc;        //证件名称

    public RylbVo(){}

    public RylbVo(Tgxx tgxx, Integer xmid) {
        this.hdid = tgxx.getId();
        this.xmid = xmid;
        this.lbbs = 0;
        this.zjbs = 0;

        String ryyq = tgxx.getRyyq();
        String bmyq = tgxx.getBmyq();

        if( ryyq != null && ryyq.length() > 0 ) {
            ryyq = ryyq.replaceAll(" ", "");
            ryyq = ryyq.replaceAll("，", ",");

            String[] lbs = ryyq.split(",");
            if( lbs.length > 0 ) {
                lbbs = 1;
                lbmcs = new ArrayList<>();
                for( String s : lbs ) {
                    Map<String, String> m = new HashMap<>();
                    m.put("label", s);
                    m.put("value", s);
                    lbmcs.add(m);
                }
            }
        }

        if( bmyq != null && bmyq.length() > 0 ) {
            bmyq = bmyq.trim();
            if( bmyq.length() > 1 ) {
                this.zjbs = 1;
                this.zjmc = bmyq;
            }
        }
    }

}
