package com.coob.modules.api.vo;

import com.coob.modules.tg.domain.Tgxm;
import com.coob.modules.tg.domain.Xmhx;
import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.domain.Xmxx;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class XmxxVo implements Serializable {
    private static final long serialVersionUID = -1L;

    private Integer hdid;
    private Integer xmid;
    private String ksrq;        //活动开始日期
    private String jzrq;        //活动截止日期
    private String xmmc;        //项目名称
    private String qymc;        //开发企业
    private String qxmc;        //区县名称
    private String jsdz;        //项目地址
    private String kpsj;        //开盘时间
    private String jhjfsj;      //计划交房时间
    private BigDecimal xsjg;	//销售价格
    private String xsdh;		//销售电话
    private String kfdh;        //看房电话
    private Integer bmrs;       //报名人数（已x人成团）
    private List<String> yhs;    // 优惠活动

    private List<String> hxs;   //在售户型
    private List<XmtpVo> xgts;  //效果图图地址列表
    private List<XmtpVo> hxts;  //户型图地址列表
    private List<XmtpVo> gsts;  //公示图
    private List<String> yszhs;  //预售证号列表

    public XmxxVo(){}

    public XmxxVo(Integer hdid, Xmxx xm){
        this.hdid = hdid;
        this.xmid = xm.getId();
        this.xmmc = xm.getXmmc();
        this.qymc = xm.getQymc();
        this.qxmc = xm.getQxmc();
        this.jsdz = xm.getJsdz();
        this.kpsj = xm.getKpsj();
        if(xm.getSfxf() != null && xm.getSfxf() == 1){
            this.jhjfsj = "现房";
        }else {
            this.jhjfsj = xm.getJhjfrq();
        }
        this.xsjg = xm.getXsjg();
        this.xsdh = xm.getXsdh();
        this.kfdh = xm.getKfdh();
        this.bmrs = xm.getBmrs();
    }

    public void putHx(Xmhx hx) {
        if( this.hxs == null ) {
            this.hxs = new ArrayList<>();
        }
        this.hxs.add(hx.getHx());
    }

    public void putXgt(Xmtp tp) {
        if( this.xgts == null ) {
            this.xgts = new ArrayList<>();
        }
        this.xgts.add(new XmtpVo(tp.getUrl(),tp.getSlturl(),tp.getYsturl()));
    }

    public void putHxt(Xmtp tp) {
        if( this.hxts == null ) {
            this.hxts = new ArrayList<>();
        }
        this.hxts.add(new XmtpVo(tp.getUrl(),tp.getSlturl(),tp.getYsturl()));
    }

    public void putYh(Tgxm tgxm) {
        if( this.yhs == null ) {
            this.yhs = new ArrayList<>();
        }
        this.yhs.add(tgxm.getYh3sm());
        this.yhs.add(tgxm.getYh5sm());
        this.yhs.add(tgxm.getYh10sm());
        this.yhs.add(tgxm.getYhqtsm());
    }

    public void putYhzh(String yszh) {
        if( this.yszhs == null ) {
            this.yszhs = new ArrayList<>();
        }
        this.yszhs.add(yszh);
    }

    /**
     * 公示图
     * @param tp
     */
    public void putGst(Xmtp tp) {
        if( this.gsts == null ) {
            this.gsts = new ArrayList<>();
        }
        this.gsts.add(new XmtpVo(tp.getUrl(),tp.getSlturl(),tp.getYsturl()));
    }
}
