package com.coob.modules.tg.controller;

import com.coob.aframe.base.BaseController;
import com.coob.modules.tg.domain.Tgry;
import com.coob.modules.tg.domain.Tgxm;
import com.coob.modules.tg.domain.Tgxx;
import com.coob.modules.tg.service.TgryService;
import com.coob.modules.tg.service.TgxmService;
import com.coob.modules.tg.service.TgxxService;
import com.coob.modules.tg.service.TgyhService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 企业端团购业务
 * 1、展示未关闭的所有的 团购信息
 */
@RequestMapping("/tgyw/cx")
@Controller
public class QyTgywCxController extends BaseController {
    @Resource
    private TgxxService tgxxService;
    @Resource
    private TgxmService tgxmService;
    @Resource
    private TgyhService tgyhService;
    @Resource
    private TgryService tgryService;

    /**
     * 团购查询-列表
     *
     * @param model
     * @return
     */
    @RequestMapping(value = "/doList")
    public String doListV(String tgmc, Model model) {
        Map<String, Object> params = new HashMap<>();
        params.put("tgmc", tgmc);
        super.setParamToSession(params);

        super.offsetPage(1);
        List<Tgxx> list = this.tgxxService.selectByParams(params);
        PageInfo<Tgxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("tgmc", tgmc);

        return "pages/ywglQy/tgywcx/list";
    }
    /**
     * 团购查询-列表
     *
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String,Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<Tgxx> list = this.tgxxService.selectByParams(params);
        PageInfo<Tgxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("tgmc", params.get("tgmc"));

        return "pages/ywglQy/tgywcx/list";
    }

    /**
     * 查看详细信息
     *
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toView")
    public String toView(Integer id, Model model) {
        //查询托管信息
        Tgxx tgxx = this.tgxxService.selectById(id);
        //查询参数项目
        model.addAttribute("tgxx", tgxx);
        return "pages/ywglQy/tgywcx/view";
    }

    /**
     * 显示项目列表
     * @param tgid
     * @param model
     * @return
     */
    @RequestMapping(value = "/xmList")
    public String xmList(Integer tgid, Model model) {
        Integer qyid = this.getCurrentUser().getDepartId();

        // 1、查询团购信息绑定的团购项目
        List<Tgxm> tgxmList = this.tgxmService.selectListXmByTgidAndQyid(tgid, qyid);

        //查询报名人员
        List<Tgry> tgryList = this.tgryService.selectListByTgid(tgid);

        for (Tgxm tx : tgxmList) {
            if(tgryList != null){
                for (Tgry tgry : tgryList) {
                    //已推送本项目的 报名人员 推送状态 1 未推送 2 已推送
                    if(tgry.getTszt() == 2 && tx.getId().equals(tgry.getTgxmid())){
                        tx.putTgry(tgry);
                    }
                }
            }
        }

        model.addAttribute("tgxmList", tgxmList);

        return "pages/ywglQy/tgywcx/xmList";
    }

    /**
     * 查看人员列表
     * @param txid
     * @param model
     * @return
     */
    @RequestMapping("/ryList")
    public String ryList(Integer txid, Model model){
        List<Tgry> ryList = this.tgryService.selectListByTgxmid(txid, 2);
        model.addAttribute("ryList", ryList);

        return "pages/ywglQy/tgywcx/ryList";
    }
}
