package com.coob.modules.tg.controller;

import com.coob.aframe.base.Application;
import com.coob.aframe.base.BaseController;
import com.coob.aframe.base.LoginUser;
import com.coob.aframe.base.R;
import com.coob.aframe.util.DateUtil;
import com.coob.aframe.util.FileUtil;
import com.coob.aframe.util.UUIDUtil;
import com.coob.modules.tg.domain.Tgxm;
import com.coob.modules.tg.domain.Tgxx;
import com.coob.modules.tg.domain.Xmhx;
import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.domain.Xmxx;
import com.coob.modules.tg.domain.XmxxZj;
import com.coob.modules.tg.service.TgxmService;
import com.coob.modules.tg.service.TgxxService;
import com.coob.modules.tg.service.XmhxService;
import com.coob.modules.tg.service.XmtpService;
import com.coob.modules.tg.service.XmxxService;
import com.coob.modules.tg.service.XmZjService;
import com.coob.system.domain.Area;
import com.coob.system.service.AreaService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 项目信息管理
 *  开发企业用户维护本企业下的项目信息
 */
@RequestMapping("/xmxx/qy")
@Controller
public class QyXmxxController extends BaseController {
    @Resource
    private AreaService areaService;
    @Resource
    private XmxxService xmxxService;
    @Resource
    private XmhxService xmhxService;
    @Resource
    private XmtpService xmtpService;
    @Resource
    private TgxmService tgxmService;
    @Resource
    private XmZjService xmZjService;
    @Resource
    private TgxxService tgxxService;


    /**
     * 查询列表
     * @param model
     * @return
     */
    @RequestMapping(value = "/doList", method = {RequestMethod.GET, RequestMethod.POST})
    public String doList(String xmmc, Model model) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("xmmc", xmmc);
        params.put("qyid", this.getCurrentUser().getDepartId());
        params.put("state", 1);
        this.setParamToSession(params);

        super.offsetPage(1);
        List<Xmxx> list = this.xmxxService.selectByParams(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("xmmc", xmmc);

        return "pages/ywglQy/xmxx/list";
    }

    /**
     * Session分页处理
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String,Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<Xmxx> list = this.xmxxService.selectByParams(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("xmmc", (String)params.get("xmmc"));

        return "pages/ywglQy/xmxx/list";
    }


    /**
     * 进入新增页面
     * @param model
     * @return
     */
    @RequestMapping(value = "/toAdd")
    public String toAdd(Model model) {
        Xmxx xmxx = new Xmxx();

        LoginUser curU = this.getCurrentUser();
        xmxx.setQyid(curU.getDepartId());
        xmxx.setQymc(curU.getDepartName());

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("qxlist", this.areaService.selectListForPage());

        return "pages/ywglQy/xmxx/add";
    }

    /**
     * 保存新增信息
     * @param xmxx
     * @param model
     * @return
     */
    @RequestMapping(value = "/doAdd")
    public String doAdd(Xmxx xmxx, Model model) {
        // 判断是否已存在
        Xmxx xm = xmxxService.selectByXmmc(xmxx.getXmmc(), xmxx.getQx());
        if (xm != null) {
            alert("保存失败, 该项目已存在");
            model.addAttribute("xmxx", xmxx);
            model.addAttribute("qxlist", this.areaService.selectList());
            return "pages/ywgl/xmxx/add";
        }
        Area area = areaService.selectByid(xmxx.getQx());
        xmxx.setQxmc(area.getQxmc());
        xmxx.setZt(1); // 暂存
        xmxx.setState(1);

        LoginUser currentUser = this.getCurrentUser();
        xmxx.setCzr(currentUser.getUserName());
        xmxx.setCzsj(DateUtil.getCurTime());

        this.xmxxService.insert(xmxx);

        this.alert("信息保存成功");

        return toEdit(xmxx.getId(), model);
    }


    /**
     * 进入修改页面
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toEdit")
    public String toEdit(Integer id, Model model) {
        //查询项目信息
        Xmxx xmxx = this.xmxxService.selectById(id);

        //查询户型列表
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(id);

        //查询效果图
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(id, 1);

        //查询户型图
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(id, 2);
        //查询公示图
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(id, 3);
        // 查询证件
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(id,null);

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("qxlist", this.areaService.selectList());
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("zjList", zjList);

        return "pages/ywglQy/xmxx/edit";
    }

    /**
     * 保存修改信息
     * @param xmxx
     * @param model
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/doEdit", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R doEdit(Xmxx xmxx, Model model) {
        // 判断是否已存在
        Xmxx xm = xmxxService.selectByXmmc(xmxx.getXmmc(), xmxx.getQx());
        if (xm != null && !xm.getId().equals(xmxx.getId())) {
            return R.error().put("msg", "保存失败, 该项目已存在");
        }

        Area area = areaService.selectByid(xmxx.getQx());
        xmxx.setQxmc(area.getQxmc());
        xmxx.setState(1);
        xmxx.setCzr(this.getCurrentUser().getUserName());
        xmxx.setCzsj(DateUtil.getCurTime());

        this.xmxxService.update(xmxx);
        return R.ok().put("msg", "信息保存成功");
    }

    /**
     * 提交项目信息
     * @param xmxx
     * @param model
     * @return
     */
    @RequestMapping(value = "/doSub")
    public String doSub(Xmxx xmxx, Model model) {
        Integer xmid = xmxx.getId();

        //查询户型列表
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(xmid);
        if( hxList == null || hxList.size() == 0 ) {
            alert("没有填写在售户型");
            return toEdit(xmid, model);
        }

        //查询效果图
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(xmid, 1);
        if( xgtList == null || xgtList.size() == 0 ) {
            alert("没有上传效果图");
            return toEdit(xmid, model);
        }

        //查询户型图
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(xmid, 2);
        if( hxtList == null || hxtList.size() == 0 ) {
            alert("没有上传户型图");
            return toEdit(xmid, model);
        }

        List<XmxxZj> zjList = this.xmZjService.selectByXmid(xmid,null);
        if(zjList == null || zjList.size() ==0){
            alert("没有填写预售/现售证号信息");
            return toEdit(xmid, model);
        }


        Area area = areaService.selectByid(xmxx.getQx());
        xmxx.setQxmc(area.getQxmc());
        xmxx.setCzr(this.getCurrentUser().getUserName());
        xmxx.setCzsj(DateUtil.getCurTime());
        xmxx.setZt(2);
        // 清空审核信息
        xmxx.setShyj("");
        xmxx.setShsj("");
        xmxx.setShry("");

        this.xmxxService.update(xmxx);

        return "redirect:doList";
    }


    /**
     * 删除信息
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/doDel")
    public String doDel(Integer id, Model model) {
        Xmxx xmxx = this.xmxxService.selectById(id);
        if(xmxx.getZt() != 1 && xmxx.getZt() != 3){
            this.alert("项目非编辑状态，不允许删除");
            return "redirect:doList";
        }
        List<Tgxx> tgxxs = tgxxService.selectListByXmid(id,null);
        if(tgxxs != null && tgxxs.size() > 0){
            alert("有参团的项目不允许删除");
        }else {
            this.xmxxService.deleteById(id);
            alert("信息删除成功");
        }
        return "redirect:doList";
    }

    /**
     * 显示项目详情
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toView")
    public String toView(Integer id, Model model) {
        //查询项目信息
        Xmxx xmxx = this.xmxxService.selectById(id);

        //查询户型列表
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(id);

        //查询效果图
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(id, 1);

        //查询户型图
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(id, 2);
        //查询公示图
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(id, 3);
        //参与的团购信息
        List<Tgxm> tgList = this.tgxmService.selectListTgByXmid(id, null);
        // 查询证件
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(id,null);

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("tgList", tgList);
        model.addAttribute("zjList", zjList);

        return "pages/ywglQy/xmxx/view";
    }

    /**
     * 保存证件信息
     * @param xmzj
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/savezj", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R savezj(XmxxZj xmzj){
        // 获取项目审核信息
        LoginUser currentUser = this.getCurrentUser();
        if(currentUser.getUserType() ==1 || currentUser.getUserType() ==2){
            xmzj.setXz(0);
        }else {
            xmzj.setXz(1);
        }
        xmzj.setCreatTime(DateUtil.getCurTime());
        XmxxZj dbxmzj = this.xmZjService.selectByXmidLxZsh(xmzj.getXmid(),xmzj.getLx(),xmzj.getZsh());
        if(dbxmzj != null){
            return R.error("保存失败, 证件重复");
        }
        int flag = this.xmZjService.insert(xmzj);
        return R.ok("信息保存成功").put("xmzj", xmzj);
    }

    /**
     * 删除证件信息
     * @param id
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/delZj", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R delZj(Integer id) {
        this.xmZjService.deleteById(id);
        return R.ok("信息删除成功");
    }

    /**
     * 保存户型信息
     * @param xmhx
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/saveHx", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R saveHx(Xmhx xmhx){
        xmhx.init();

        int flag = this.xmhxService.saveXmhx(xmhx);
        if( flag == -1 ) {
            return R.error("保存失败, 户型重复");
        } else {
            return R.ok("信息保存成功").put("xmhx", xmhx);
        }
    }

    /**
     * 删除户型信息
     * @param id
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/delHx", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R delHx(Integer id) {
        this.xmhxService.delXmhx(id);
        return R.ok("信息删除成功");
    }



    @ResponseBody
    @RequestMapping(value = "/xmtps", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R xmtps(Integer xmid, Integer lb) {
        List<Xmtp> list = this.xmtpService.selectListByXmid(xmid, lb);
        return R.ok().put("list", list);
    }

    /**
     *
     * @param xmid
     * @param lb
     * @param model
     * @return
     */
    @RequestMapping(value = "/toUpload")
    public String toUpload(Integer xmid, Integer lb, Model model) {
        model.addAttribute("xmid", xmid);
        model.addAttribute("lb", lb);

        return "pages/ywglQy/xmxx/upload";
    }

    /**
     * 上传附件
     * @param xmid
     * @param lb
     * @param response
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/upload", method = RequestMethod.POST, produces = "application/json;charset=utf8")
    public R upload(Integer xmid, Integer lb, @RequestParam MultipartFile[] upfiles, HttpServletResponse response){
        //创建路径
        String urlMk = DateUtil.getCurDateStr("yyyy/MM/dd/");
        String bPath = Application.Upload_File_Path;
        FileUtil.mkDir(bPath + urlMk);

        List<Xmtp> tpList = new ArrayList<>();
        String czr = this.getCurrentUser().getUserName();
        for (MultipartFile file : upfiles) {
            //本地缓存文件路径
            String _fName = file.getOriginalFilename();
            String _Format = _fName.substring(_fName.lastIndexOf("."));
            String uuid = UUIDUtil.getUUID();

            String fileName = uuid + _Format;
            String sltFileName = uuid + "slt" + _Format;
            String ystFileName = uuid + "yst" + _Format;

            String url = urlMk + fileName;
            String slturl = urlMk + sltFileName;
            String ysturl = urlMk + ystFileName;

            try {
                //保存文件
                FileUtil.saveFile(file, bPath + url);
                // 生成压缩文件
                boolean flag = FileUtil.imgThumbnail(file, bPath + ysturl);
                // 不压缩则压缩路径为原路径
                if(!flag){
                    ysturl = url;
                }
                // 生成缩略图
                FileUtil.imgThumbnail(file.getInputStream(), bPath + slturl, 172, 229);

                //添加数据
                Xmtp xmtp = new Xmtp(xmid, lb, url,slturl, ysturl,czr);
                tpList.add(xmtp);

            } catch (IOException e) {
                e.printStackTrace();
                return R.error("上传失败" + e.getMessage());
            }
        }

        //保存数据
        this.xmtpService.insertBatch(tpList);

        return R.ok("上传成功");
    }

    /**
     * 每月销售价格 公示价格一览表
     * @param file
     */
    @ResponseBody
    @RequestMapping(value = "/uploadGdt", method={RequestMethod.POST, RequestMethod.GET}, produces = "application/json;charset=utf-8") // 防止json传输出现乱码
    public R uploadGdt(Integer xmid,@RequestParam("file") MultipartFile file) {
        String urlMk = DateUtil.getCurDateStr("yyyy/MM/dd/");
        String bPath = Application.Upload_File_Path;
        FileUtil.mkDir(bPath + urlMk);

        String czr = this.getCurrentUser().getUserName();
        //本地缓存文件路径
        String _fName = file.getOriginalFilename();
        String _Format = _fName.substring(_fName.lastIndexOf("."));
        String uuid = UUIDUtil.getUUID();
        String fileName = uuid + _Format;
        String sltFileName = uuid + "slt" + _Format;
        String ystFileName = uuid + "yst" + _Format;

        String url = urlMk + fileName;
        String slturl = urlMk + sltFileName;
        String ysturl = urlMk + ystFileName;

        Xmtp xmtp = null;
        Integer lb = 3;
        try {
            //保存文件
            FileUtil.saveFile(file, bPath + url);
            // 生成压缩文件
            boolean flag = FileUtil.imgThumbnail(file, bPath + ysturl);
            // 不压缩则压缩路径为原路径
            if(!flag){
                ysturl = url;
            }
            // 生成缩略图
            FileUtil.imgThumbnail(file.getInputStream(), bPath + slturl, 210, 300);
            //添加数据
            xmtp = new Xmtp(xmid, lb, url,slturl,ysturl, czr);
            int del = xmtpService.deleteByXmidAndLb(xmid, lb);
            //保存数据
            this.xmtpService.insert(xmtp);

            List<Xmtp> list = this.xmtpService.selectListByXmid(xmid, lb);
            return R.ok().put("list", list);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return R.error();
    }


    @ResponseBody
    @RequestMapping(value = "/delXmtp", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
    public R delXmtp(Integer id) {
        Xmtp xmtp = this.xmtpService.selectById(id);
        this.xmtpService.deleteById(id);
        return R.ok("删除成功").put("lb", xmtp.getLb());
    }
}
