package com.coob.modules.tg.controller;

import com.coob.aframe.base.BaseController;
import com.coob.modules.tg.domain.Qyxx;
import com.coob.modules.tg.service.QyxxService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (TQyxx)表控制层
 *
 * @author makejava
 * @since 2024-08-01 17:01:36
 */
@Controller
@RequestMapping("/ywcx/qyxx")
public class QyxxCxController extends BaseController {
    @Resource
    private QyxxService qyxxService;

    /**
     * 查询企业信息列表
     *
     * @param qymc
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doList")
    public String doList(String qymc, Integer pageNum, Model model) {
        Map<String, Object> params = new HashMap<>();
        params.put("qymc", qymc);
        params.put("state", 1);
        super.setParamToSession(params);

        super.offsetPage(pageNum);
        List<Qyxx> list = this.qyxxService.selectByParams(params);
        PageInfo<Qyxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("qymc", qymc);

        return "pages/ywcxQy/qyxx/list";
    }
    /**
     * 查询企业信息列表
     *
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String, Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<Qyxx> list = this.qyxxService.selectByParams(params);
        PageInfo<Qyxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("qymc", params.get("qymc"));

        return "pages/ywcxQy/qyxx/list";
    }

    /**
     * 企业详情
     *
     * @param model
     * @return
     */
    @RequestMapping(value = "/toCurrentQyView")
    public String toCurrentQyView(Model model) {
        Integer departId = this.getCurrentUser().getDepartId();
        Qyxx qyxx = this.qyxxService.selectById(departId);
        model.addAttribute("qyxx", qyxx);
        return "pages/ywcx/qyxx/view";
    }

    /**
     * 企业详情
     *
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toView")
    public String toView(Integer id, Model model) {
        Qyxx qyxx = this.qyxxService.selectById(id);
        model.addAttribute("qyxx", qyxx);
        return "pages/ywcxQy/qyxx/view";
    }
}

