package com.coob.modules.tg.controller;

import com.coob.aframe.base.BaseController;
import com.coob.aframe.base.LoginUser;
import com.coob.aframe.util.DateUtil;
import com.coob.modules.tg.domain.Tgxm;
import com.coob.modules.tg.domain.Tgxx;
import com.coob.modules.tg.domain.Xmhx;
import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.domain.Xmxx;
import com.coob.modules.tg.domain.XmxxZj;
import com.coob.modules.tg.service.TgxmService;
import com.coob.modules.tg.service.TgxxService;
import com.coob.modules.tg.service.TgyhService;
import com.coob.modules.tg.service.XmZjService;
import com.coob.modules.tg.service.XmhxService;
import com.coob.modules.tg.service.XmtpService;
import com.coob.modules.tg.service.XmxxService;
import com.coob.system.service.AreaService;
import com.github.pagehelper.PageInfo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 项目信息审核
 *  开发企业针对团购活动添加项目后，需要区县业务部门审核
 *
 */
@RequestMapping("/tgxm/sh")
@Controller
public class TgxmShController extends BaseController {
    @Resource
    private AreaService areaService;
    @Resource
    private TgxmService tgxmService;
    @Resource
    private XmxxService xmxxService;
    @Resource
    private TgxxService tgxxService;
    @Resource
    private XmhxService xmhxService;
    @Resource
    private XmtpService xmtpService;
    @Resource
    private TgxxController tgxxController;
    @Resource
    private XmZjService xmZjService;


    /**
     * 获取- 获取本区县-待审核的团购项目列表
     * @param tgmc
     * @param xmmc
     * @param model
     * @return
     */
    @RequestMapping(value = "/doList", method = {RequestMethod.GET, RequestMethod.POST})
    public String doList(String tgmc, String qymc, String xmmc, Model model) {
        //获取本区县需要审核的团购项目
        LoginUser currentUser = this.getCurrentUser();

        Map<String, Object> params = new HashMap<String, Object>();
        if(currentUser.getUserType() >= 2){
            params.put("qx", currentUser.getQx());
        }
        params.put("tgmc", tgmc);
        params.put("qymc", qymc);
        params.put("xmmc", xmmc);
        params.put("shzt", 1);
        params.put("jzzt", 4);

        this.setParamToSession(params);
        super.offsetPage(1);

        List<Tgxm> list = this.tgxmService.selectByParams(params);
        PageInfo<Tgxm> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("tgmc", tgmc);
        model.addAttribute("qymc", qymc);
        model.addAttribute("xmmc", xmmc);

        return "pages/ywgl/tgxmSh/list";
    }

    /**
     * 获取- 获取本区县-待审核的团购项目列表
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage", method = {RequestMethod.GET, RequestMethod.POST})
    public String doPage(Integer pageNum, Model model) {
        Map<String,Object> params = this.getSessionParam();
        // 获取本区县需要审核的团购项目
        super.offsetPage(pageNum);

        List<Tgxm> list = this.tgxmService.selectByParams(params);
        PageInfo<Tgxm> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("tgmc", params.get("tgmc"));
        model.addAttribute("qymc", params.get("qymc"));
        model.addAttribute("xmmc", params.get("xmmc"));

        return "pages/ywgl/tgxmSh/list";
    }


    /**
     * 跳转审核页面
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toSh")
    public String toSh(Integer id, Model model) {
        Tgxm tgxm = this.tgxmService.selectById(id);
        Integer tgid = tgxm.getTgid();
        Integer xmid = tgxm.getXmid();

        Tgxx tgxx = this.tgxxService.selectById(tgid);
        Xmxx xmxx = this.xmxxService.selectById(xmid);
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(xmid);
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(xmid, 1);
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(xmid, 2);
        //查询公示图
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(xmid, 3);
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(xmid,null);

        //统计项目参加的活动数量
        int tgs = this.tgxmService.selectCountByXmid(xmid);
        xmxx.setTgs(tgs);

        model.addAttribute("tgxx", tgxx);
        model.addAttribute("tgxm", tgxm);
        model.addAttribute("xmxx", xmxx);
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("zjList", zjList);

        return "pages/ywgl/tgxmSh/sh";
    }

    /**
     * 审核
     * @param tgxm
     * @param model
     * @return
     */
    @RequestMapping(value = "/doSh")
    public String doSh(Tgxm tgxm, Model model) {
        LoginUser currentUser = this.getCurrentUser();
        tgxm.setShry(currentUser.getUserName());
        tgxm.setShsj(DateUtil.getCurTime());

        //保存审核信息：保存信息、更新团购项目数、保存优惠活动
        this.tgxmService.saveShenhe(tgxm);

        this.alert("审核完成");

        return "redirect:doList";
    }

    /**
     * 撤销审核
     *
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toCxsh")
    public String toCxsh(Integer id, Model model) {
        Tgxm tgxm = this.tgxmService.selectById(id);
        Xmxx xmxx = this.xmxxService.selectById(tgxm.getXmid());
        model.addAttribute("tgxm", tgxm);
        model.addAttribute("xmxx", xmxx);
        return "pages/ywgl/tgxmSh/cxsh";
    }

    /**
     * 审核
     * @param tgxm
     * @param model
     * @return
     */
    @RequestMapping(value = "/doCx")
    public String doCx(Tgxm tgxm, Model model) {
        LoginUser currentUser = this.getCurrentUser();
        tgxm.setShry(currentUser.getUserName());
        tgxm.setShsj(DateUtil.getCurTime());

        //保存审核信息：保存信息、更新团购项目数、保存优惠活动
        this.tgxmService.saveCx(tgxm);
        this.alert("撤销完成");
        return tgxxController.toView(tgxm.getTgid(),model);
    }

    /**
     * 根据团购ID，查询已经参与的项目列表
     * @param tgid
     * @param model
     * @return
     */
    @RequestMapping(value = "/toXms")
    public String toXms(Integer tgid, Integer qx, String xmmc, Model model) {
        //查询参与托管，且已经审核通过的项目
        List<Xmxx> xmList = this.xmxxService.selectListByTgid(tgid, qx, xmmc, 2);

        model.addAttribute("xmList", xmList);
        model.addAttribute("areaList", this.areaService.selectList());
        model.addAttribute("tgid", tgid);
        model.addAttribute("qx", qx);
        model.addAttribute("xmmc", xmmc);

        return "pages/ywgl/tgxmSh/xms";
    }


    /**
     * 根据项目ID，查询已经参与的团购列表
     * @param xmid
     * @param model
     * @return
     */
    @RequestMapping(value = "/toTgs")
    public String toTgs(Integer xmid, Model model) {
        List<Tgxx> tgList = this.tgxxService.selectListByXmid(xmid, 2);

        model.addAttribute("tgList", tgList);

        return "pages/ywgl/tgxmSh/tgs";
    }

}
