package com.coob.modules.tg.controller;

import com.coob.aframe.base.Application;
import com.coob.aframe.base.R;
import com.coob.aframe.util.FileUtil;
import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.service.XmtpService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RequestMapping("/xmxx/xmtp")
@RestController
public class XmtpController {
    @Resource
    private XmtpService xmtpService;

    /**
     * 压缩图地址为空的图片 生成压缩图
     *
     * @return
     */
    @RequestMapping(value = "/createYstUrl", method = {RequestMethod.GET, RequestMethod.POST})
    public R createYstUrl() {
        Map<String, Object> params = new HashMap<>();
        params.put("state", 1);
        params.put("ysturlnull", 0);
        List<Xmtp> xmtps = xmtpService.selectByParams(params);
        for (Xmtp xmtp : xmtps) {
            if (!StringUtils.isBlank(xmtp.getYsturl())) {
                continue;
            }
            // 生成压缩图
            String ystUrl = createYstUrl(xmtp);
            if (!StringUtils.isBlank(ystUrl)) {
                xmtpService.update(new Xmtp(xmtp.getId(), null, ystUrl));
            }
        }
        return R.ok().put("msg", "生成压缩图成功");
    }

    /**
     * 缩略图地址为空的图片 生成缩略图
     *
     * @return
     */
    @RequestMapping(value = "/createSltUrl", method = {RequestMethod.GET, RequestMethod.POST})
    public R createSltUrl() {
        Map<String, Object> params = new HashMap<>();
        params.put("state", 1);
        params.put("slturlnull", 0);
        List<Xmtp> xmtps = xmtpService.selectByParams(params);
        for (Xmtp xmtp : xmtps) {
            if (!StringUtils.isBlank(xmtp.getSlturl())) {
                continue;
            }
            // 生成压缩图
            String sltUrl = createSltUrl(xmtp);
            if (!StringUtils.isBlank(sltUrl)) {
                xmtpService.update(new Xmtp(xmtp.getId(), sltUrl, null));
            }
        }
        return R.ok().put("msg", "生成缩略图成功");
    }

    private String createYstUrl(Xmtp xmtp) {
        try {
            // 1、生成压缩图路径
            String[] split = xmtp.getUrl().split("\\.");
            String ysturl = split[0] + "yst." + split[1];
            String bPath = Application.Upload_File_Path;
            // 读取文件并上传,并转换类型
            File file = new File(bPath + xmtp.getUrl());
            file.getParentFile().mkdirs();
            FileInputStream input = new FileInputStream(file);
            MultipartFile multipartFile = new MockMultipartFile("file", file.getName(), "text/plain", input);
            // 上传文件
            boolean flag = FileUtil.imgThumbnail(multipartFile, bPath + ysturl);
            // 不压缩则压缩路径为原路径
            if (!flag) {
                ysturl = xmtp.getUrl();
            }
            return ysturl;
        } catch (Exception e) {
            System.out.println("上传历史图片缩略图失败" + e.getMessage());
            e.printStackTrace();
            return null;
        }
    }

    private String createSltUrl(Xmtp xmtp) {
        try {
            String[] split = xmtp.getUrl().split("\\.");
            String slturl = split[0] + "slt." + split[1];
            String bPath = Application.Upload_File_Path;
            // 读取文件并上传
            File file = new File(bPath + xmtp.getUrl());
            file.getParentFile().mkdirs();
            FileInputStream fileInputStream = new FileInputStream(file);
            FileUtil.imgThumbnail(fileInputStream, bPath + slturl, 172, 229);
            return slturl;
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("上传历史图片缩略图失败" + e.getMessage());
            return null;
        }
    }
}
