package com.coob.modules.tg.controller;

import com.coob.aframe.base.BaseController;
import com.coob.aframe.base.LoginUser;
import com.coob.aframe.util.DateUtil;
import com.coob.modules.tg.domain.Xmhx;
import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.domain.Xmxx;
import com.coob.modules.tg.domain.XmxxZj;
import com.coob.modules.tg.service.XmZjService;
import com.coob.modules.tg.service.XmhxService;
import com.coob.modules.tg.service.XmtpService;
import com.coob.modules.tg.service.XmxxService;
import com.coob.system.service.AreaService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 项目信息审核
 *  开发企业针对团购活动新增楼盘项，需要区县业务部门审核
 *
 */
@RequestMapping("/xmxx/sh")
@Controller
public class XmxxShController extends BaseController {
    @Resource
    private AreaService areaService;
    @Resource
    private XmxxService xmxxService;
    @Resource
    private XmhxService xmhxService;
    @Resource
    private XmtpService xmtpService;
    @Resource
    private XmZjService xmZjService;
    /**
     *
     * @param qymc
     * @param xmmc
     * @param zt
     * @return
     */
    @RequestMapping(value = "/doList", method = {RequestMethod.GET, RequestMethod.POST})
    public String doList(String qymc, String xmmc, Integer zt, Model model) {
        Map<String, Object> params = new HashMap<String, Object>();
        LoginUser currentUser = this.getCurrentUser();
        if(currentUser.getUserType() >= 2){
            params.put("qx", currentUser.getQx());
        }
        params.put("qymc", qymc);
        params.put("xmmc", xmmc);

        params.put("zt", zt);
        params.put("kszt", 2);
        params.put("state", 1);
        params.put("shpx", 1);
        this.setParamToSession(params);

        super.offsetPage(1);
        List<Xmxx> list = this.xmxxService.selectByParams(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("qymc", qymc);
        model.addAttribute("xmmc", xmmc);
        model.addAttribute("zt", zt);

        return "pages/ywgl/xmxxSh/list";
    }

    /**
     * Session分页处理
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String,Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<Xmxx> list = this.xmxxService.selectByParams(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("qymc", params.get("qymc"));
        model.addAttribute("xmmc", params.get("xmmc"));
        model.addAttribute("zt", params.get("zt"));

        return "pages/ywgl/xmxxSh/list";
    }


    /**
     * 进入修改页面
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toEdit")
    public String toEdit(Integer id, Model model) {
        //查询项目信息
        Xmxx xmxx = this.xmxxService.selectById(id);

        //查询户型列表
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(id);

        //查询效果图
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(id, 1);

        //查询户型图
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(id, 2);

        //查询公示图
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(id, 3);
        // 查询证件
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(id,null);

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("qxlist", this.areaService.selectList());
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("zjList", zjList);

        return "pages/ywgl/xmxxSh/edit";
    }


    /**
     * 显示项目详情
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toView")
    public String toView(Integer id, Model model) {
        //查询项目信息
        Xmxx xmxx = this.xmxxService.selectById(id);
        //查询户型列表

        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(id);

        //查询效果图
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(id, 1);

        //查询户型图
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(id, 2);
        //查询公示图
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(id, 3);
        // 查询证件
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(id,null);

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("zjList", zjList);

        return "pages/ywgl/xmxxSh/view";
    }

    /**
     * 跳转审核页面
     *
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toSh")
    public String toSh(Integer id, Model model) {
        Xmxx xmxx = this.xmxxService.selectById(id);
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(id);
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(id, 1);
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(id, 2);
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(id, 3);
        // 查询证件
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(id,null);

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("zjList", zjList);

        return "pages/ywgl/xmxxSh/sh";
    }

    /**
     * 审核
     * @param xmxx
     * @param model
     * @return
     */
    @RequestMapping(value = "/doSh")
    public String doSh(Xmxx xmxx, Model model) {
        xmxx.setShry(this.getCurrentUser().getUserName());
        xmxx.setShsj(DateUtil.getCurTime());

        int update = this.xmxxService.update(xmxx);
        if(update >0){
            if(xmxx.getZt() == 5){
                this.xmZjService.updateXzByXmid(xmxx.getId(),0);
            }
        }
        this.alert("审核完成");

        return "redirect:doList";
    }
}
