package com.coob.modules.tg.controller;

import com.coob.aframe.base.BaseController;
import com.coob.modules.tg.domain.Tgry;
import com.coob.modules.tg.domain.Tgxm;
import com.coob.modules.tg.domain.Tgxx;
import com.coob.modules.tg.domain.TgxxTj;
import com.coob.modules.tg.service.TgryService;
import com.coob.modules.tg.service.TgxmService;
import com.coob.modules.tg.service.TgxxService;
import com.coob.modules.tg.service.TgyhService;
import com.coob.system.domain.Area;
import com.coob.system.service.AreaService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 企业端团购业务
 * 1、展示未关闭的所有的 团购信息
 */
@RequestMapping("/ywcx/tgxx")
@Controller
public class YwcxTgxxController extends BaseController {
    @Resource
    private AreaService areaService;
    @Resource
    private TgxxService tgxxService;
    @Resource
    private TgxmService tgxmService;
    @Resource
    private TgryService tgryService;

    /**
     * 查询托管信息列表
     * 仅查询进行中的托管信息
     *
     * @param tgmc
     * @return
     */
    @RequestMapping(value = "/doList")
    public String doList(String tgmc,Integer zt, Model model) {
        Map<String, Object> params = new HashMap<>();
//        LoginUser currentUser = this.getCurrentUser();
//        Integer qx = currentUser.getQx();
//        if (qx != null && qx != 0) {
//            params.put("qx", qx);
//        }
        params.put("tgmc", tgmc);
        params.put("zt", zt);
        super.setParamToSession(params);

        super.offsetPage(1);
        List<Tgxx> list = this.tgxxService.selectByParams(params);
        PageInfo<Tgxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("tgmc", tgmc);
        model.addAttribute("zt", zt);

        return "pages/ywcx/tgxx/list";
    }

    /**
     * Session分页处理
     *
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String, Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<Tgxx> list = this.tgxxService.selectByParams(params);
        PageInfo<Tgxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("tgmc", (String) params.get("tgmc"));

        return "pages/ywcx/tgxx/list";
    }

    /**
     * 查看团购详情
     *
     * @param id
     * @param model
     * @return
     */
    @RequestMapping("/toView")
    public String toView(Integer id, Model model) {
        //查询托管信息
        Tgxx tgxx = this.tgxxService.selectById(id);
        model.addAttribute("tgxx", tgxx);
        return "pages/ywcx/tgxx/view";
    }

    /**
     * 显示项目列表
     *
     * @param tgid
     * @param model
     * @return
     */
    @RequestMapping(value = "/xmList")
    public String xmList(Integer tgid, Integer qx, String xmmc, Model model) {
        Tgxx tgxx = this.tgxxService.selectById(tgid);
        List<Tgxm> xmList = this.tgxmService.selectListXmByTgid(tgid, qx, xmmc, null);
        List<Area> qyList = this.areaService.selectList();

        model.addAttribute("tgxx", tgxx);
        model.addAttribute("xmList", xmList);
        model.addAttribute("qyList", qyList);
        model.addAttribute("tgid", tgid);
        model.addAttribute("qx", qx);
        model.addAttribute("xmmc", xmmc);

        return "pages/ywcx/tgxx/xmList";
    }

    /**
     * 查看人员列表
     *
     * @param txid
     * @param model
     * @return
     */
    @RequestMapping("/ryList")
    public String ryList(Integer txid, Model model) {
        List<Tgry> ryList = this.tgryService.selectListByTgxmid(txid, 2);
        model.addAttribute("ryList", ryList);

        return "pages/ywcx/tgxx/ryList";
    }

    /**
     * 统计：报名活动开始统计
     * 1、活动数: 参与报名、结束、关闭的活动 zt>=2 <=5
     * 2、项目数
     * 3、浏览数
     * 4、报名数
     *
     * @param txid
     * @param model
     * @return
     */
    @RequestMapping("/tj")
    public String tj(Integer txid, Model model) {

        TgxxTj tgxxTj = this.tgxxService.TgxxTj();
        model.addAttribute("tgxxTj", tgxxTj);
        return "pages/ywcx/tgxx/tgxxtj";
    }
}
