package com.coob.modules.tg.controller;

import com.coob.aframe.base.Application;
import com.coob.aframe.base.BaseController;
import com.coob.aframe.base.LoginUser;
import com.coob.aframe.base.R;
import com.coob.aframe.util.DateUtil;
import com.coob.aframe.util.FileUtil;
import com.coob.aframe.util.UUIDUtil;
import com.coob.modules.tg.domain.Tgxm;
import com.coob.modules.tg.domain.Xmhx;
import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.domain.Xmxx;
import com.coob.modules.tg.domain.XmxxZj;
import com.coob.modules.tg.service.TgxmService;
import com.coob.modules.tg.service.XmZjService;
import com.coob.modules.tg.service.XmhxService;
import com.coob.modules.tg.service.XmtpService;
import com.coob.modules.tg.service.XmxxService;
import com.coob.system.domain.Area;
import com.coob.system.service.AreaService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 项目信息管理
 * 开发企业用户维护本企业下的项目信息
 */
@RequestMapping("/ywcxQy/xmxx")
@Controller
public class YwcxXmxxQyController extends BaseController {
    @Resource
    private XmxxService xmxxService;
    @Resource
    private XmhxService xmhxService;
    @Resource
    private XmtpService xmtpService;
    @Resource
    private TgxmService tgxmService;
    @Resource
    private XmZjService xmZjService;


    /**
     * 查询列表
     *
     * @param model
     * @return
     */
    @RequestMapping(value = "/doList", method = {RequestMethod.GET, RequestMethod.POST})
    public String doList(String xmmc, Integer sgzt, Integer sfss, Integer zt, Model model) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("xmmc", xmmc);
        params.put("sgzt", sgzt);
        params.put("sfss", sfss);
        params.put("zt", zt);
        params.put("qyid", this.getCurrentUser().getDepartId());
        params.put("state", 1);
        this.setParamToSession(params);

        super.offsetPage(1);
        List<Xmxx> list = this.xmxxService.selectByParams(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("xmmc", xmmc);
        model.addAttribute("sgzt", sgzt);
        model.addAttribute("sfss", sfss);
        model.addAttribute("zt", zt);

        return "pages/ywcxQy/xmxx/list";
    }

    /**
     * Session分页处理
     *
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String, Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<Xmxx> list = this.xmxxService.selectByParams(params);
        PageInfo<Xmxx> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("xmmc", (String) params.get("xmmc"));

        return "pages/ywcxQy/xmxx/list";
    }

    /**
     * 显示项目详情
     *
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toView")
    public String toView(Integer id, Model model) {
        //查询项目信息
        Xmxx xmxx = this.xmxxService.selectById(id);

        //查询户型列表
        List<Xmhx> hxList = this.xmhxService.selectHxListByXmid(id);

        //查询效果图
        List<Xmtp> xgtList = this.xmtpService.selectListByXmid(id, 1);

        //查询户型图
        List<Xmtp> hxtList = this.xmtpService.selectListByXmid(id, 2);
        //查询公示图
        List<Xmtp> gstList = this.xmtpService.selectListByXmid(id, 3);
        //参与的团购信息
        List<Tgxm> tgList = this.tgxmService.selectListTgByXmid(id, null);
        // 查询证件
        List<XmxxZj> zjList = this.xmZjService.selectByXmid(id, null);

        model.addAttribute("xmxx", xmxx);
        model.addAttribute("hxList", hxList);
        model.addAttribute("xgtList", xgtList);
        model.addAttribute("hxtList", hxtList);
        model.addAttribute("gstList", gstList);
        model.addAttribute("tgList", tgList);
        model.addAttribute("zjList", zjList);

        return "pages/ywcxQy/xmxx/view";
    }

}
