package com.coob.modules.tg.dao;

import java.util.List;
import java.util.Map;

import com.coob.modules.api.vo.BmjxVo;
import com.coob.modules.tg.domain.Tgry;
import org.apache.ibatis.annotations.Param;

public interface TgryDao {

	/**
	 * 新增
	 * @param tgry
	 * @return
	 */
	int insert(Tgry tgry);

	/**
	 * 修改
	 * @param tgry
	 * @return
	 */
	int update(Tgry tgry);

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	int deleteById(Integer id);

	/**
	 * 物理删除
	 * @param id
	 * @return
	 */
	int physicalDeleteById(Integer id);

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	Tgry selectById(Integer id);

	/**
	 * 根据 tgid查询团购人员信息
	 * @param tgid
	 * @return
	 */
	List<Tgry> selectListByTgid(Integer tgid);

	/**
	 * 根据 tgxmid查询团购人员信息
	 * @return
	 */
	List<Tgry> selectListByTgxmid(@Param("tgxmid") Integer tgxmid, @Param("shzt") Integer shzt);

	/**
	 * 报名检查，同一活动、项目，同一手机号只能有1条数据
	 * @param tgid
	 * @param xmid
	 * @param sjhm
	 * @return
	 */
	Tgry selectForCheck(@Param("tgid")Integer tgid, @Param("xmid")Integer xmid, @Param("sjhm")String sjhm);

	/**
	 * 根据手机号，查询团购报名记录，用于微信展示
	 * @param tgid
	 * @param sjhm
	 * @return
	 */
	List<BmjxVo> selectListBySjhmForWx(@Param("tgid")Integer tgid, @Param("sjhm")String sjhm);

	/**
	 * 条件查询列表
	 * @param params
	 * @return
	 */
	List<Tgry> selectByParams(Map<String, Object> params);

}
