package com.coob.modules.tg.dao;

import java.util.List;
import java.util.Map;

import com.coob.modules.api.vo.GdTgxmVo;
import com.coob.modules.tg.domain.Tgxm;
import org.apache.ibatis.annotations.Param;

public interface TgxmDao {

	/**
	 * 新增
	 * @param tgxm
	 * @return
	 */
	int insert(Tgxm tgxm);

	/**
	 * 修改
	 * @param tgxm
	 * @return
	 */
	int update(Tgxm tgxm);

	/**
	 * 更新浏览数
	 * @param id
	 * @return
	 */
	int updateLlsById(Integer id);

	/**
	 * 更新浏览数
	 * @param tgid
	 * @param xmid
	 * @return
	 */
	int updateLlsByTgidAndXmid(@Param("tgid")Integer tgid, @Param("xmid")Integer xmid);

	/**
	 * 更新报名人数
	 * @param id
	 * @return
	 */
	int updateBmrsById(Integer id);

	/**
	 * 更新成交人数
	 * @param id
	 * @return
	 */
	int updateCjrsById(Integer id);

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	int deleteById(Integer id);

	/**
	 * 按项目ID，统计参加活动数量（仅统计审核通过的）
	 * @param xmid
	 * @return
	 */
	int selectCountByXmid(Integer xmid);

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	Tgxm selectById(Integer id);

	/**
	 * 根据团购id和项目id查询团购项目
	 * @param tgid
	 * @param xmid
	 * @return
	 */
	Tgxm selectByTgidAndXmid(@Param("tgid") Integer tgid,@Param("xmid") Integer xmid);

	/**
	 * 根据团购ID，查询信息，并级联查询项目信息
	 * @param tgid
	 * @param shzts
	 * @return
	 */
	List<Tgxm> selectListXmByTgid(@Param("tgid") Integer tgid, @Param("qx") Integer qx, @Param("xmmc") String xmmc, @Param("shzts")String shzts);

	/**
	 * 根据项目ID，查询信息，并级联查询团购信息
	 * @param xmid
	 * @param shzt
	 * @return
	 */
	List<Tgxm> selectListTgByXmid(@Param("xmid")Integer xmid, @Param("shzt")Integer shzt);

	/**
	 * 根据企业和团购信息id 查询企业名下的团购项目
	 * @param tgid
	 * @param qyid
	 * @return
	 */
	List<Tgxm> selectListXmByTgidAndQyid(@Param("tgid") Integer tgid,@Param("qyid") Integer qyid);
	/**
	 * 条件查询列表
	 * @param params
	 * @return
	 */
	List<Tgxm> selectByParams(Map<String, Object> params);

	/**
	 * 根据团购id，查询已经审核通过的项目信息，用于导出Excel
	 * @param tgid
	 * @return
	 */
	List<Tgxm> selectXmListForExport(Integer tgid);

	/**
	 * 获取报名人数最多的楼盘
	 * 获取未结束的团购2、审批通过2（注意未撤销的-2） 团购项目 报名人数前十的项目信息
	 * @param limit
	 * @return
	 */
	List<GdTgxmVo> selectLpsByBmrs();
}
