package com.coob.modules.tg.dao;

import com.coob.modules.tg.domain.Tgxx;
import com.coob.modules.tg.domain.TgxxTj;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 团购信息(Tgxx)表数据库访问层
 *
 * @author makejava
 * @since 2024-08-01 17:02:08
 */
public interface TgxxDao {

    /**
     * 新增数据
     * @param Tgxx 实例对象
     * @return 影响行数
     */
    int insert(Tgxx Tgxx);

    /**
     * 修改数据
     * @param Tgxx 实例对象
     * @return 影响行数
     */
    int update(Tgxx Tgxx);

    /**
     * 计算并修改项目数  只统计 shzt  2 审核通过
     * @param id
     */
    int updateXms(Integer id);

    /**
     * 更新浏览数
     * @param id
     * @return
     */
    int updateLls(Integer id);

    /**
     * 更新报名人数
     * @param id
     * @return
     */
    int updateBmrs(Integer id);

    /**
     * 更新成交人数
     * @param id
     * @return
     */
    int updateCjrs(Integer id);

    /**
     * 通过主键删除数据
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过ID查询单条数据
     * @param id 主键
     * @return 实例对象
     */
    Tgxx selectById(Integer id);

    /**
     * 查询微信展示的活动列表
     * @return
     */
    List<Tgxx> selectListForWx();

    /**
     * 根据企业获取团购信息
     * @param qyid
     * @return
     */
    List<Tgxx> selectByQyid(Integer qyid);

    /**
     * 根据项目ID，查询参与的活动列表
     * @param xmid
     * @return
     */
    List<Tgxx> selectListByXmid(@Param("xmid") Integer xmid, @Param("shzt")Integer shzt);

    /**
     * 条件查询列表
     * @param params 查询条件
     * @return
     */
    List<Tgxx> selectByParams(Map<String, Object> params);

    /**
     * 统计：报名活动开始统计
     * 1、活动数: 参与报名、结束、关闭的活动 zt>=2 <=5
     * 2、项目数
     * 3、浏览数
     * 4、报名数
     *
     * @return
     */
    TgxxTj TgxxTj();
}
