package com.coob.modules.tg.dao;

import java.util.List;
import java.util.Map;

import com.coob.modules.tg.domain.Tgyh;
import org.apache.ibatis.annotations.Param;

public interface TgyhDao {

	/**
	 * 新增
	 * @param tgyh
	 * @return
	 */
	int insert(Tgyh tgyh);

	/**
	 * 批量添加
	 * @param list
	 * @return
	 */
	int insertBatch(List<Tgyh> list);

	/**
	 * 逻辑删除
	 * @param tgid
	 * @param xmid
	 * @return
	 */
	int deleteByTgidXmid(@Param("tgid") Integer tgid,@Param("xmid")Integer xmid);

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	Tgyh selectById(Integer id);

	/**
	 * 根据团购ID和项目ID，查询列表
	 * @param tgid
	 * @param xmid
	 * @return
	 */
	List<Tgyh> selectListByTgidAndXmid(@Param("tgid")Integer tgid, @Param("xmid")Integer xmid);

	/**
	 * 查询项目最后生效的优惠措施
	 * @param xmid
	 * @return
	 */
	List<Tgyh> selectListLastByXmid(Integer xmid);

	/**
	 * 根据团购ID，查询优化列表
	 * @param tgid
	 * @return
	 */
	List<Tgyh> selectListByTgid(Integer tgid);
}
