package com.coob.modules.tg.dao;

import com.coob.modules.tg.domain.Xmtp;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 项目图片管理
 */
public interface XmtpDao {

	/**
	 * 新增
	 * @param xmtp
	 * @return
	 */
	int insert(Xmtp xmtp);

	/**
	 * 批量新增
	 * @param list
	 * @return
	 */
	int insertBatch(List<Xmtp> list);

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	int deleteById(Integer id);

	/**
	 * 根据项目id和类别删除
	 * @param xmid
	 * @param lb
	 * @return
	 */
	int deleteByXmidAndLb(@Param("xmid") Integer xmid,@Param("lb")  Integer lb);

	/**
	 * 更新
	 * @param xmtp
	 * @return
	 */
	int update(Xmtp xmtp);

	/**
	 * 根据id查询
	 * @param id
	 * @return
	 */
	Xmtp selectById(Integer id);

	/**
	 * 查询项目图片列表
	 * @param xmid
	 * param lb
	 * @return
	 */
	List<Xmtp> selectListByXmid(@Param("xmid")Integer xmid, @Param("lb")Integer lb);

	/**
	 * 根据托管ID，按项目分组查询第一张效果图，用于微信展示项目列表
	 * @param tgid
	 * @return
	 */
	List<Xmtp> selectListXgtByTgidForWx(Integer tgid);

	List<Xmtp> selectByParams(Map<String, Object> params);

}
