package com.coob.modules.tg.dao;

import com.coob.modules.tg.domain.Xmxx;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 楼盘基本信息管理Dao
 */
public interface XmxxDao {

    /**
     * 新增
     * @param xmxx
     * @return
     */
    int insert(Xmxx xmxx);

    /**
     * 修改
     * @param xmxx
     * @return
     */
    int update(Xmxx xmxx);

    /**
     * 逻辑删除
     * @param id
     * @return
     */
    int deleteById(Integer id);

    /**
     * 根据id查询信息
     * @param id
     * @return
     */
    Xmxx selectById(Integer id);

    /**
     * 根据项目名称查询项目信息
     * @param xmmc
     * @return
     */
    Xmxx selectByXmmc(@Param("xmmc")String xmmc, @Param("qx")Integer qx);

    /**
     * 根据企业id查询 审核通过项目列表
     * @param qyid
     * @return
     */
    List<Xmxx> selectListShtgByQyid(Integer qyid);

    /**
     * 根据托管ID，查询参数与的项目信息
     * @param tgid
     * @param shzt
     * @return
     */
    List<Xmxx> selectListByTgid(@Param("tgid")Integer tgid, @Param("qx") Integer qx, @Param("xmmc") String xmmc, @Param("shzt")Integer shzt);

    /**
     * 查询活动下的项目信息，用于微信展示
     * @return
     */
    List<Xmxx> selectListByTgidForWx(Map<String,Object> params);

    /**
     * 条件查询列表
     * @param params
     * @return
     */
    List<Xmxx> selectByParams(Map<String, Object> params);


}
