package com.coob.modules.tg.dao;

import java.util.List;
import java.util.Map;

import com.coob.modules.tg.domain.XmxxZj;
import org.apache.ibatis.annotations.Param;

public interface XmxxZjDao {

    /**
     * 新增
     *
     * @param xmxxZj
     * @return
     */
    int insert(XmxxZj xmxxZj);

    /**
     * 修改
     *
     * @param xmxxZj
     * @return
     */
    int update(XmxxZj xmxxZj);

    /**
     * 根据项目id 修改证件状态
     * @param xmid
     * @param xz
     */
    int updateXzByXmid(@Param("xmid") Integer xmid,@Param("xz")  int xz);

    /**
     * 删除
     *
     * @param id
     * @return
     */
    int deleteById(Integer id);

    /**
     * 根据id查询信息
     *
     * @param id
     * @return
     */
    XmxxZj selectById(Integer id);

    /**
     * 根据Xmid查询信息
     *
     * @param xmid
     * @return
     */
    List<XmxxZj> selectByXmid(@Param("xmid")Integer xmid,@Param("xz") Integer xz);

    /**
     * 根据Xmid 类型和证书号获取项目证件信息
     *
     * @param lx
     * @param zsh
     * @return
     */
    XmxxZj selectByXmidLxZsh(@Param("xmid") Integer xmid,@Param("lx") Integer lx, @Param("zsh") String zsh);

    /**
     * 条件查询列表
     *
     * @param params
     * @return
     */
    List<XmxxZj> selectByParams(Map<String, Object> params);

}
