package com.coob.modules.tg.domain;

import com.coob.aframe.util.DateUtil;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

@Data
public class Tgry implements Serializable {
	private static final long serialVersionUID = 1L;

	private Integer id;		//
	private Integer tgid;	//团购id
	private Integer xmid;	//项目id
	private Integer tgxmid;	//关联表ID
	private String xm;		//姓名
	private String sjhm;	//手机号码
	private String rylb;	//人员类别
	private String zjhm;	//证件号码
	private String bmsj;	//报名时间
	private Integer shzt;	//审核状态 1 未审核 2 审核通过 3、审核驳回
	private String shry;	//审核人
	private String shsj;    //审核时间
	private String shyj;    //审核意见
	private Integer tszt;	//推送状态 1 未推送 2 已推送
	private String tsr;		//推送人
	private String tssj;	//推送时间
	private Integer cjzt;	//成交状态 1 未成交 2 已成交
	private String cjr;		//成交人
	private String cjsj;	//成交时间
	private Integer state;	//

	private String tgmc;    //团购名称
	private String qymc;    //企业名称
	private String xmmc;    //项目名称
	private String qxmc;    //区县名称

	public Tgry(){}

	public Tgry(Tgxm tgxm, String xm, String sjhm, String rylb, String zjhm){
		this.tgid = tgxm.getTgid();
		this.xmid = tgxm.getXmid();
		this.tgxmid = tgxm.getId();
		this.xm = xm;
		this.sjhm = sjhm;
		this.rylb = rylb;
		this.zjhm = zjhm;
		this.bmsj = DateUtil.getCurTime();
		this.shzt = 1;
		this.tszt = 1;
		this.cjzt = 1;
		this.state = 1;
	}

	public String getBmrq() {
		if(this.bmsj != null && this.bmsj.length() > 10 ) {
			return this.bmsj.substring(0,10);
		}
		return "";
	}

}

