package com.coob.modules.tg.domain;

import com.coob.aframe.util.DateUtil;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class Tgxm implements Serializable {
    private static final long serialVersionUID = 1L;

    private Integer id;     //
    private Integer tgid;   //团购id
    private Integer xmid;   //项目id
    private Integer qyid;   //企业id
    private Integer qx;     //区县
    private String yh3;     //[3,5]人团优惠
    private String yh5;     //[5,10]人团优惠
    private String yh10;     //11+团优惠
    private String yhqt;     //其他优惠

    private String tjr;     //提交人
    private String tjsj;    //提交时间
    private Integer shzt;   //审核状态 -2 撤销 -1驳回 1待审核 2 审核通过
    private String shry;     //审核人
    private String shsj;    //审核时间
    private String shyj;    //审核意见
    private Integer lls;    //浏览数
    private Integer bmrs;   //报名人数
    private Integer cjrs;   //成交人数
    private Integer state;  //1 -9 删除

    private String tgmc;        // 团购名称
    private String ksrq;        // 开始日期
    private String jzrq;        // 截止日期
    private Integer tgzt;         // 状态：0暂存 1提交（企业可以报名） 2发布（微信展示） 4结束（不可报名团购）  5关闭（企业不可标记成交） 6撤销（企业不可标记成交）
    private String fbsj;        // 发布时间
    private String jssj;        // 结束时间
    private Integer xms;        // 项目数  审核通过的才算数


    private String qymc;    //企业名称
    private String xmmc;    //项目名称
    private String qxmc;    //区县名称
    private String jsdz;		//项目地址
    private String kpsj;		//开盘时间 yyyy年MM月dd日
    private String jhjfrq;		//计划交房日期
    private Integer sgzt;		//施工状态:1\  正常施工  2\停工停建 3\建设完成
    private Integer sfss;		//涉法涉诉：0 否 1是
    private Integer sfxf;		//是否现房：0 否 1是
    private BigDecimal xsjg;	//销售价格
    private String xsdh;		//销售电话
    private String kfdh;		//看房直通车联系电话

    private Tgxx tgxx;
    private Xmxx xmxx;          //对应的项目信息
    private List<Tgry> tgryList;    // 项目团购人员


    public Tgxm(){}

    public void initData(Xmxx xm,String tjr) {
        this.xmid = xm.getId();
        this.qyid = xm.getQyid();
        this.qx = xm.getQx();
        this.tjr = tjr;
        this.tjsj = DateUtil.getCurTime();
        this.shzt = 1;
        this.lls = 0;
        this.bmrs = 0;
        this.cjrs = 0;
        this.state =1;
    }


//    public void putTgyh(Tgyh tgyh) {
//        if( this.yhList == null ) {
//            this.yhList = new ArrayList<>();
//        }
//        this.yhList.add(tgyh);
//    }

    public void putTgry(Tgry tgry) {
        if( this.tgryList == null ) {
            this.tgryList = new ArrayList<>();
        }
        this.tgryList.add(tgry);
    }

    public String checkAdd(){
        if(this.tgid == null){
            return "团购活动信息为空 , 请重试";
        }
        if(this.xmid == null){
            return "楼盘活动信息为空 , 请重试";
        }
        if(this.yh3 == null || this.yh3.isEmpty()){
            return "3-5人团（含3、5人）优惠 , 不能为空";
        }
        if(this.yh5 == null || this.yh5.isEmpty()){
            return "6-10人团（含10人）优惠 , 不能为空";
        }
        if(this.yh10 == null || this.yh10.isEmpty()){
            return "10人以上团优惠 , 不能为空";
        }
        return null;
    }

    public boolean checkYh() {
        if(this.yh3 == null || this.yh3.isEmpty()){
            return true;
        }
        if(this.yh5 == null || this.yh5.isEmpty()){
            return true;
        }
        if(this.yh10 == null || this.yh10.isEmpty()){
            return true;
        }
        return false;
    }


    public String getYh3sm() {
        StringBuffer s = new StringBuffer("3-5人团（含3、5人）优惠：");
        return s.append(this.yh3).toString();
    }
    public String getYh5sm() {
        StringBuffer s = new StringBuffer("6-10人团（含10人）优惠：");
        return s.append(this.yh5).toString();
    }
    public String getYh10sm() {
        StringBuffer s = new StringBuffer("10人以上团优惠：");
        return s.append(this.yh10).toString();
    }
    public String getYhqtsm() {
        StringBuffer s = new StringBuffer("其他优惠：");
        String yhqt = StringUtils.isBlank(this.yhqt) ? "无" :this.yhqt;
        return s.append(yhqt).toString();
    }

}

