package com.coob.modules.tg.domain;

import lombok.Data;

import java.io.Serializable;

/**
 * 团购优惠活动信息
 * 可以按不动活动、不同项目设置优惠
 */
@Data
public class Tgyh implements Serializable {
    private static final long serialVersionUID = 1L;

    private Integer id;        //
    private Integer tgid;    //团购活动id
    private Integer xmid;    //项目ID
    private Integer tgxmid;    //团购项目关联表ID
    private Integer ksrs;    //开始人数， 如人数3 = 大于或等于3个人
    private Integer jzrs;    //截止人数
    private String yhhd;    //优惠活动 说明
    private String czr;        //操作人
    private String czsj;    //操作时间
    private Integer state;    //

    //拼接优惠说明
    public String getYhsm() {
        StringBuffer s = new StringBuffer("" + ksrs);
        if (jzrs > 0) {
            s.append("-").append(jzrs).append("人团");
        } else {
            s.append("人(或以上)团");
        }
        s.append(" (").append(yhhd).append(")");

        return s.toString();
    }

    public boolean checkCfjc(Integer ksrs, Integer jzrs) {
        if (this.ksrs.equals(ksrs)) {
            return true;
        } else if (this.ksrs.equals(jzrs)) {
            return true;
        } else if (this.jzrs.equals(ksrs)) {
            return true;
        } else if (this.jzrs.equals(jzrs)) {
            return true;
        }
        return false;
    }
}

