package com.coob.modules.tg.domain;

import com.coob.aframe.util.DateUtil;
import lombok.Data;
import java.io.Serializable;

/**
 * 项目图片信息管理
 */
@Data
public class Xmtp implements Serializable {
	private static final long serialVersionUID = 1L;

	private Integer id;		//
	private Integer lb;		//类别 1效果图 2户型图 3 价格公示图
	private Integer xmid;	//项目id
	private Integer hxid;	//所属户型id，暂时不用 全=0
	private String tpmc;	//图片名称：效果图、户型图
	private String url;		//图片路径
	private String slturl;	//缩略图片路径
	private String ysturl;	//压缩图片路径
	private Integer sxh;	//顺序号 = 0
	private String czr;		//操作人
	private String czsj;	//操作时间
	private Integer state;	//

	public Xmtp(){}

	public Xmtp(Integer xmid, Integer lb, String url,String slturl,String ysturl, String czr) {
		this.lb = lb;
		this.xmid = xmid;
		this.hxid = 0;
		if( lb == 1 ) {
			this.tpmc = "效果图";
		} else if(lb == 2 ){
			this.tpmc = "户型图";
		}  else if(lb == 3 ) {
			this.tpmc = "公示图";
		}  else  {
			this.tpmc = "";
		}
		this.url = url;
		this.slturl = slturl;
		this.ysturl = ysturl;
		this.sxh = 0;
		this.czr = czr;
		this.czsj = DateUtil.getCurTime();
		this.state = 1;
	}

	public Xmtp(Integer id, String sltUrl, String ysturl) {
		this.id = id;
		this.slturl = sltUrl;
		this.ysturl = ysturl;
	}
}

