package com.coob.modules.tg.service;

import com.coob.modules.tg.dao.QyxxDao;
import com.coob.modules.tg.domain.Qyxx;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * (TQyxx)表服务实现类
 *
 * @author makejava
 * @since 2024-08-01 17:01:36
 */
@Service
@Transactional
public class QyxxService {
    @Resource
    private QyxxDao qyxxDao;


    /**
     * 新增数据
     * @param qyxx 实例对象
     * @return 实例对象
     */

    public int insert(Qyxx qyxx) {
        int flag = this.qyxxDao.insert(qyxx);
        return flag;
    }

    /**
     * 修改数据
     * @param qyxx 实例对象
     * @return 实例对象
     */

    public int update(Qyxx qyxx) {
        int flag = this.qyxxDao.update(qyxx);
        return flag;
    }

    /**
     * 通过主键删除数据
     * @param id 主键
     * @return 是否成功
     */

    public int deleteById(Integer id) {
        int flag = this.qyxxDao.deleteById(id);
        return flag;
    }

    /**
     * 通过ID查询单条数据
     * @param id 主键
     * @return 实例对象
     */

    public Qyxx selectById(Integer id) {
        Qyxx qyxx =  this.qyxxDao.selectById(id);
        return qyxx;
    }

    /**
     * 根据名称查询，判断是否重复
     * @param qymc
     * @return
     */
    public Qyxx selectByQymc(String qymc) {
        Qyxx qyxx = this.qyxxDao.selectByQymc(qymc);
        return qyxx;
    }

    /**
     * 查询所有列表
     * @return
     */
     public List<Qyxx> selectListAll(){
         return this.qyxxDao.selectListAll();
     }

    /**
     * 条件查询
     * @param params
     * @return
     */
    public List<Qyxx> selectByParams(Map<String, Object> params) {
        List<Qyxx> list = this.qyxxDao.selectByParams(params);
        return list;
    }

}
