package com.coob.modules.tg.service;

import com.coob.modules.tg.dao.TgxxDao;
import com.coob.modules.tg.domain.Tgxx;
import com.coob.modules.tg.domain.TgxxTj;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 团购信息(TTgxx)表服务实现类
 *
 * @author makejava
 * @since 2024-08-01 17:02:08
 */
@Service
@Transactional
public class TgxxService {
    @Resource
    private TgxxDao tgxxDao;

    /**
     * 新增数据
     *
     * @param tgxx 实例对象
     * @return 实例对象
     */
    public int insert(Tgxx tgxx) {
        return this.tgxxDao.insert(tgxx);
    }

    /**
     * 修改数据
     *
     * @param tgxx 实例对象
     * @return 实例对象
     */
    public int update(Tgxx tgxx) {
        return this.tgxxDao.update(tgxx);
    }

    /**
     * 计算并修改项目数  只统计 shzt  2 审核通过
     * @param id
     */
    public int updateXms(Integer id) {
        return this.tgxxDao.updateXms(id);
    }

    /**
     * 更新浏览数
     * @param id
     * @return
     */
    public int updateLls(Integer id){
        return this.tgxxDao.updateLls(id);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */

    public int deleteById(Integer id) {
        return this.tgxxDao.deleteById(id);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    public Tgxx selectById(Integer id) {
        return this.tgxxDao.selectById(id);
    }


    /**
     * 查询微信展示的活动列表
     * @return
     */
    public List<Tgxx> selectListForWx(){
        List<Tgxx> list = this.tgxxDao.selectListForWx();
        return list;
    }


    /**
     * 根据项目ID，查询参与的活动列表
     * @param xmid
     * @return
     */
    public List<Tgxx> selectListByXmid(Integer xmid, Integer shzt) {
        List<Tgxx> list = this.tgxxDao.selectListByXmid(xmid, shzt);
        return list;
    }


    /**
     * 条件查询列表
     *
     * @param params 查询条件
     * @return
     */
    public List<Tgxx> selectByParams(Map<String, Object> params) {
        return this.tgxxDao.selectByParams(params);
    }

    /**
     * 根据企业获取团购信息
     * @param qyid
     * @return
     */
    public List<Tgxx> selectByQyid(Integer qyid) {
        return this.tgxxDao.selectByQyid(qyid);
    }

    /**
     * 统计：报名活动开始统计
     * 1、活动数: 参与报名、结束、关闭的活动 zt>=2 <=5
     * 2、项目数
     * 3、浏览数
     * 4、报名数
     *
     * @return
     */
    public TgxxTj TgxxTj() {
        return this.tgxxDao.TgxxTj();
    }
}
