package com.coob.modules.tg.service;

import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.coob.modules.tg.domain.Tgyh;
import com.coob.modules.tg.dao.TgyhDao;

@Service
@Transactional
public class TgyhService {
	@Autowired
	private TgyhDao tgyhDao;


	/**
	 * 新增
	 * @param tgyh
	 * @return
	 */
	public int insert(Tgyh tgyh){
		int flag = this.tgyhDao.insert(tgyh);
		return flag;
	}

	/**
	 * 新增
	 * @param tgyh
	 * @return
	 */
	public int insertBatch(List<Tgyh> tgyh){
		int flag = this.tgyhDao.insertBatch(tgyh);
		return flag;
	}


	/**
	 * 删除
	 * @param tgid
	 * @param xmid
	 * @return
	 */
	public int deleteByTgidXmid(Integer tgid,Integer xmid){
		int flag = this.tgyhDao.deleteByTgidXmid(tgid,xmid);
		return flag;
	}


	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	public Tgyh selectById(Integer id){
		Tgyh tgyh = this.tgyhDao.selectById(id);
		return tgyh;
	}

	/**
	 * 根据团购ID和项目ID，查询列表
	 * @param tgid
	 * @param xmid
	 * @return
	 */
	public List<Tgyh> selectListByTgidAndXmid(Integer tgid, Integer xmid) {
		List<Tgyh> list = this.tgyhDao.selectListByTgidAndXmid(tgid, xmid);
		return list;
	}

	/**
	 * 查询项目最后生效的优惠措施
	 * @param xmid
	 * @return
	 */
	public List<Tgyh> selectListLastByXmid(Integer xmid){
		List<Tgyh> list = this.tgyhDao.selectListLastByXmid(xmid);
		return list;
	}

	/**
	 * 根据团购ID，查询优化列表
	 * @param tgid
	 * @return
	 */
	public List<Tgyh> selectListByTgid(Integer tgid){
		List<Tgyh> list = this.tgyhDao.selectListByTgid(tgid);
		return list;
	}
}
