package com.coob.modules.tg.service;

import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.coob.modules.tg.domain.XmxxZj;
import com.coob.modules.tg.dao.XmxxZjDao;

@Service
@Transactional
public class XmZjService {
	@Autowired
	private XmxxZjDao xmxxZjDao;


	/**
	 * 新增
	 * @param xmxxZj
	 * @return
	 */
	public int insert(XmxxZj xmxxZj){
		int flag = this.xmxxZjDao.insert(xmxxZj);
		return flag;
	}


	/**
	 * 修改
	 * @param xmxxZj
	 * @return
	 */
	public int update(XmxxZj xmxxZj){
		int flag = this.xmxxZjDao.update(xmxxZj);
		return flag;
	}

	/**
	 * 根据项目id 修改证件状态
	 * @param xmid
	 * @param xz
	 */
	public int updateXzByXmid(Integer xmid, int xz) {
		return this.xmxxZjDao.updateXzByXmid(xmid,xz);
	}

	/**
	 * 删除
	 * @param id
	 * @return
	 */
	public int deleteById(Integer id){
		int flag = this.xmxxZjDao.deleteById(id);
		return flag;
	}

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	public XmxxZj selectById(Integer id){
		return this.xmxxZjDao.selectById(id);
	}

	/**
	 * 根据Xmid查询信息
	 * @param xmid
	 * @param xz
	 * @return
	 */
	public List<XmxxZj> selectByXmid(Integer xmid,Integer xz){
		return this.xmxxZjDao.selectByXmid(xmid,xz);
	}

	/**
	 * 根据Xmid 类型和证书号获取项目证件信息
	 * @param lx
	 * @param zsh
	 * @return
	 */
	public XmxxZj selectByXmidLxZsh(Integer xmid,Integer lx, String zsh) {
		return this.xmxxZjDao.selectByXmidLxZsh(xmid,lx,zsh);
	}

	/**
	 * 条件查询列表
	 * @param params
	 * @return
	 */
	public List<XmxxZj> selectByParams(Map<String,Object> params){
		return this.xmxxZjDao.selectByParams(params);
	}

}
