package com.coob.modules.tg.service;

import com.coob.modules.tg.dao.XmhxDao;
import com.coob.modules.tg.domain.Xmhx;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 项目户型管理
 */
@Service
@Transactional
public class XmhxService {
    @Autowired
    private XmhxDao xmhxDao;

    /**
     * 保存户型信息
     * @param xmhx
     * @return
     */
    public int saveXmhx(Xmhx xmhx) {
        int flag = 0;

        Xmhx hx = this.xmhxDao.selectByHx(xmhx.getXmid(), xmhx.getHx());

        if( hx != null ) {
            flag = -1;
        } else {
            flag = this.xmhxDao.insert(xmhx);
        }

        return flag;
    }

    /**
     * 删除户型
     * @param id
     * @return
     */
    public int delXmhx(Integer id) {
        int flag = this.xmhxDao.deleteById(id);
        return flag;
    }

    /**
     * 根据户型查询列表
     * @param xmid
     * @return
     */
    public List<Xmhx> selectHxListByXmid(Integer xmid) {
        List<Xmhx> hxList = this.xmhxDao.selectListByXmid(xmid);
        return hxList;
    }

}
