package com.coob.modules.tg.service;

import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.coob.modules.tg.domain.Xmtp;
import com.coob.modules.tg.dao.XmtpDao;

/**
 * 项目图片信息管理
 */
@Service
@Transactional
public class XmtpService {
	@Autowired
	private XmtpDao xmtpDao;


	/**
	 * 新增
	 * @param xmtp
	 * @return
	 */
	public int insert(Xmtp xmtp){
		int flag = this.xmtpDao.insert(xmtp);
		return flag;
	}

	/**
	 * 修改
	 * @param list
	 * @return
	 */
	public int insertBatch(List<Xmtp> list){
		int flag = 0;

		if( list != null && list.size() > 0 ) {
			flag = this.xmtpDao.insertBatch(list);
		}

		return flag;
	}

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	public int deleteById(Integer id){
		int flag = this.xmtpDao.deleteById(id);
		return flag;
	}

	/**
	 * 根据项目id和类别删除
	 * @param xmid
	 * @param lb
	 * @return
	 */
	public int deleteByXmidAndLb(Integer xmid, Integer lb) {
		return this.xmtpDao.deleteByXmidAndLb(xmid, lb);
	}

	public int update(Xmtp xmtp){
		int flag = this.xmtpDao.update(xmtp);
		return flag;
	}
	/**
	 * 根据id查询
	 * @param id
	 * @return
	 */
	public Xmtp selectById(Integer id){
		Xmtp xmtp = this.xmtpDao.selectById(id);
		return xmtp;
	}

	/**
	 * 条件查询列表
	 * @param mxid
	 * @param lb
	 * @return
	 */
	public List<Xmtp> selectListByXmid(Integer mxid, Integer lb){
		List<Xmtp> list = this.xmtpDao.selectListByXmid(mxid, lb);
		return list;
	}

	/**
	 * 根据托管ID，按项目分组查询第一张效果图，用于微信展示项目列表
	 * @param tgid
	 * @return
	 */
	public List<Xmtp> selectListXgtByTgidForWx(Integer tgid){
		List<Xmtp> list = this.xmtpDao.selectListXgtByTgidForWx(tgid);
		return list;
	}

	public List<Xmtp> selectByParams(Map<String, Object> params) {
		return this.xmtpDao.selectByParams(params);
	}
}
