package com.coob.modules.tg.service;

import com.coob.modules.tg.dao.XmxxDao;
import com.coob.modules.tg.domain.Xmxx;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * 项目信息管理
 */
@Service
@Transactional
public class XmxxService {
    @Autowired
    private XmxxDao xmxxDao;


    /**
     * 新增 项目基本信息
     * @param xmxx
     * @return
     */
    public int insert(Xmxx xmxx) {
        int flag = this.xmxxDao.insert(xmxx);
        return flag;
    }


    /**
     * 修改 项目基本信息
     * @param xmxx
     * @return
     */
    public int update(Xmxx xmxx) {
        int flag = this.xmxxDao.update(xmxx);
        return flag;
    }

    /**
     * 逻辑删除 项目信息
     * @param id
     * @return
     */
    public int deleteById(Integer id) {
        int flag = this.xmxxDao.deleteById(id);
        return flag;
    }


    /**
     * 根据id查询信息
     * @param id
     * @return
     */
    public Xmxx selectById(Integer id) {
        Xmxx xmxx = this.xmxxDao.selectById(id);
        return xmxx;
    }

    /**
     * 根据项目名称查询项目信息
     *  主要用于判断项目是否重复
     * @param xmmc
     * @return
     */
    public Xmxx selectByXmmc(String xmmc, Integer qx) {
        Xmxx xmxx = this.xmxxDao.selectByXmmc(xmmc, qx);
        return xmxx;
    }

    /**
     * 根据企业id查询 审核通过项目列表
     * @param qyid
     * @return
     */
    public List<Xmxx> selectListShtgByQyid(Integer qyid) {
        List<Xmxx> list = this.xmxxDao.selectListShtgByQyid(qyid);
        return list;
    }

    /**
     * 根据托管ID，查询参数与的项目信息
     * @param tgid
     * @param shzt
     * @return
     */
    public List<Xmxx> selectListByTgid(Integer tgid, Integer qx, String xmmc, Integer shzt) {
        List<Xmxx> list = this.xmxxDao.selectListByTgid(tgid, qx, xmmc, shzt);
        return list;
    }

    /**
     * 查询活动下的项目信息，用于微信展示
     * @return
     */
    public List<Xmxx> selectListByTgidForWx(Map<String,Object> params){
        List<Xmxx> list = this.xmxxDao.selectListByTgidForWx(params);
        return list;
    }

    /**
     * 条件查询列表
     * @param params
     * @return
     */
    public List<Xmxx> selectByParams(Map<String, Object> params) {
        List<Xmxx> list = this.xmxxDao.selectByParams(params);
        return list;
    }

}
