package com.coob.system.controller;

import com.coob.aframe.base.BaseController;

import com.coob.aframe.base.R;
import com.coob.system.domain.DicItem;
import com.coob.system.domain.DicType;
import com.coob.system.service.DicService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;


@RequestMapping("/sys/dic")
@Controller
public class DicController extends BaseController {
	@Autowired
	private DicService dicService;


	@RequestMapping(value = "/doList", method = {RequestMethod.GET, RequestMethod.POST})
	public String doList(String typeCode, String typeName, Model model) {
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("state", 1);
		params.put("typeCode", typeCode);
		params.put("typeName", typeName);
		this.setParamToSession(params);

		//查询字典类别
		List<DicType> list = this.dicService.selectByParams(params);

		//查询字典项
		List<DicItem> items = this.dicService.selectItemAllList();

		//数据封装
		for(DicType dicType : list){
			List<DicItem> itList = new ArrayList<>();
			for(DicItem it : items){
				if(it.getTypeCode().equals(dicType.getTypeCode())){
					itList.add(it);
				}
			}
			dicType.setItemList(itList);
		}

		model.addAttribute("typeCode", typeCode);
		model.addAttribute("typeName", typeName);
		model.addAttribute("objList", list);

		return "pages/system/dic/list";
	}


	@RequestMapping(value = "/toItem")
	public String toItem(Integer dicId, Integer itemId, Model model) {
		DicType dicType = this.dicService.selectById(dicId);
		DicItem item = null;

		if( itemId != null && itemId > 0 ){
			item = this.dicService.selectItemById(itemId);
		} else {
			item = new DicItem();
			item.setTypeCode(dicType.getTypeCode());
		}

		model.addAttribute("dicType", dicType);
		model.addAttribute("dicItem", item);

		return "pages/system/dic/item";
	}

	@ResponseBody
	@RequestMapping(value = "/saveItem", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
	public R saveItem(DicItem dicItem){
		if( dicItem.getId() != null && dicItem.getId() > 0 ){
			this.dicService.updateItem(dicItem);
		} else {
			this.dicService.insertItem(dicItem);
		}

		return R.ok().put("msg", "字典项保存成功");
	}

	@ResponseBody
	@RequestMapping(value = "/delItem", method = { RequestMethod.POST, RequestMethod.GET }, produces="application/json;charset=utf8")
	public R delItem(Integer itemId) {
		this.dicService.delItemById(itemId);

		return R.ok().put("msg", "字典项删除成功");
	}
	
	
}
