package com.coob.system.dao;

import com.coob.system.domain.Depart;
import org.apache.ibatis.session.RowBounds;

import java.util.List;
import java.util.Map;

public interface DepartDao {

	/**
	 * 新增
	 * @param depart
	 * @return
	 */
	int insert(Depart depart);

	/**
	 * 修改
	 * @param depart
	 * @return
	 */
	int update(Depart depart);

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	int deleteById(Integer id);

	/**
	 * 物理删除
	 * @param id
	 * @return
	 */
	int physicalDeleteById(Integer id);

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	Depart selectById(Integer id);

	/**
	 * 根据部门名称查询部门信息
	 * @param bmmc
	 * @return
	 */
	Depart selectByBmmc(String bmmc);
	
	/**
	 * 查询所有部门id
	 * @return
	 */
	List<Depart> selectListAll();

	/**
	 * 条件查询数量
	 * @param params
	 * @return
	 */
	int selectForCount(Map<String,Object> params);

	/**
	 * 条件查询列表（不分页）
	 * @param params
	 * @return
	 */
	List<Depart> selectByParams(Map<String,Object> params);

	/**
	 * 条件查询列表（分页）
	 * @param params
	 * @param rowBounds
	 * @return
	 */
	List<Depart> selectByParams(Map<String,Object> params, RowBounds rowBounds);

}
