package com.coob.system.dao;

import java.util.List;
import java.util.Map;

import com.coob.system.domain.DicType;
import org.apache.ibatis.session.RowBounds;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.stereotype.Repository;


/**
 * 字典类别管理Dao
 * @author JK.Sun
 * @version 20210308
 */
@MapperScan
@Repository
public interface DicTypeDao {

	int insert(DicType dicType);

	int update(DicType dicType);

	int deleteById(Integer id);

	int physicalDeleteById(Integer id);

	DicType selectById(Integer id);

	DicType selectByCode(String typeCode);
	
	int selectForCount(Map<String,Object> params);

	List<DicType> selectByParams(Map<String,Object> params);

	List<DicType> selectByParams(Map<String,Object> params, RowBounds rowBounds);

	List<DicType> selectAll();
}
