package com.coob.system.dao;

import com.coob.system.domain.Role;

import java.util.List;
import java.util.Map;


/**
 * 角色管理Dao
 * @author JK.Sun
 * @version 20210308
 */
public interface RoleDao {

	/**
	 * 新增
	 * @param role
	 * @return
	 */
	int insert(Role role);

	/**
	 * 修改
	 * @param role
	 * @return
	 */
	int update(Role role);

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	int deleteById(Integer id);

	/**
	 * 根据id查询
	 * @param id
	 * @return
	 */
	Role selectById(Integer id);

	/**
	 * 根据用户id，查询已经分配的角色
	 * @param userId
	 * @return
	 */
	List<Role> selectByUserId(Integer userId);

	/**
	 * 根据类别查询角色列表
	 * @param roleType
	 * @return
	 */
	List<Role> selectListByType(Integer roleType);

	/**
	 * 条件查询
	 * @param params
	 * @return
	 */
	List<Role> selectByParams(Map<String, Object> params);

}
