package com.coob.system.domain;

import com.coob.aframe.util.DESPwd;
import com.coob.aframe.util.MD5Util;
import lombok.Data;

import java.io.Serializable;


/**
 * 主管部门用户
 * @author Administrator
 *
 */
@Data
public class User implements Serializable {
	private static final long serialVersionUID = 1L;

	private Integer id;		//
	private Integer lb;		//类别 1市局 2区县局 3企业
	private Integer qx;		//
	private Integer bmid;	//部门id
	private String dlzh;	//登录账号
	private String dlmm;	//登录密码
	private Integer mmfs;	//密码加密方式 0明文 1des 5md5
	private String xm;		//姓名
	private String lxdh;	//联系电话
	private String ukey;	//ukey
	private Integer ukeybs;	//是否需要ukey登录  0否  1是
	private Integer glybs;	//管理员标识		当做权限标识用 0否  1是
	private String zcsj;	//注册时间
	private String dlsj;	//登录时间
	private Integer dlcs;	//登录次数
	private Integer state;	//状态

	//以下数据库字段
	private String bmmc;
	private String qymc;
	private String roles;
	private Integer roleId;

	/**
	 * 设置默认密码
	 */
	public void setDefaultPwd(){
		String pwd = "123666";
		this.mmfs = 1;
		this.dlmm = DESPwd.encrypt(pwd);
	}

	/**
	 * 密码加密
	 * @param pwd
	 * @return
	 */
	public String enCodePwd(String pwd){
		if( this.mmfs == 1 ){
			pwd = DESPwd.encrypt(pwd);

		} else if( this.mmfs == 5 ) {
			pwd = MD5Util.MD5(pwd);
		}

		return pwd;
	}
}

