package com.coob.system.service;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.coob.system.domain.Area;
import com.coob.system.dao.AreaDao;

@Service
@Transactional
public class AreaService {
	@Autowired
	private AreaDao areaDao;

	/**
	 * 条件查询列表
	 * @return
	 */
	public List<Area> selectList(){
		return this.areaDao.selectList();
	}

	public List<Area> selectListForPage(){
		List<Area> list = this.areaDao.selectList();
		Area area = new Area();
		area.setId(0);
		area.setQxbm("0");
		area.setQxmc("- 请选择 -");
		area.setState(1);

		list.add(0, area);

		return list;
	}


	/**
	 * 根据ID查询
	 * @param id
	 * @return
	 */
	public Area selectByid(Integer id) {
		return this.areaDao.selectByid(id);
	}
}
