package com.coob.system.service;

import com.coob.aframe.util.DateUtil;
import com.coob.system.dao.DepartDao;
import com.coob.system.domain.Depart;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
public class DepartService {
    @Resource
    private DepartDao departDao;

    /**
     * 新增
     * @param depart
     * @return
     */
    public int insert(Depart depart){
        depart.setGxsj(DateUtil.getCurTime());
        return this.departDao.insert(depart);
    }


    /**
     * 修改
     * @param depart
     * @return
     */
    public int update(Depart depart){
        depart.setGxsj(DateUtil.getCurTime());
        return this.departDao.update(depart);
    }


    /**
     * 逻辑删除
     * @param id
     * @return
     */
    public int deleteById(Integer id){
        return this.departDao.deleteById(id);
    }


    /**
     * 根据id查询信息
     * @param id
     * @return
     */
    public Depart selectById(Integer id){
        return this.departDao.selectById(id);
    }


    public List<Depart> selectListAll(){
        return this.departDao.selectListAll();
    }


    /**
     * 条件查询列表（不分页）
     * @param params
     * @return
     */
    public List<Depart> selectByParams(Map<String,Object> params){
        return this.departDao.selectByParams(params);
    }

}
