<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ include file="/WEB-INF/include/taglib.jsp" %>
<!DOCTYPE html>
<html>
<head>
	<title>角色信息管理</title>
	<meta content="UTF-8" />
	<link type="text/css" href="${ctxStatic}/css/style.css" rel="stylesheet"/>
	<script type="text/javascript" src="${ctxStatic}/js/jquery/jquery-3.2.1.min.js"></script>
	<script type="text/javascript" src="${ctxStatic}/js/jquery/jquery-loading.js"></script>
	<script type="text/javascript" src="${ctxStatic}/js/layer/layer.min.js"></script>

	<link type="text/css" href="${ctxStatic}/js/easyui51/themes/bootstrap/easyui.css" rel="stylesheet" />
	<script type="text/javascript" src="${ctxStatic}/js/easyui51/jquery.easyui.min.js"></script>
	<script type="text/javascript" src="${ctxStatic}/js/easyui51/exteasyui-dialog.js"></script>

	<script type="text/javascript">
		function showAddPage(){
			var url = '${ctx}/sys/role/toAdd';
			opendialog('RoleDialog', '角色新增', 800, 630, url);
		}

		function showEditPage(id){
			var url = '${ctx}/sys/role/toEdit?id=' + id;
			opendialog('RoleDialog', '角色编辑', 800, 630, url);
		}

		function showViewPage(id){
			var url = '${ctx}/sys/role/toView?id=' + id;
			opendialog('RoleDialog', '角色详情', 800, 630, url);
		}

		function closePage(reFlag){
			close('RoleDialog');
			if( reFlag ) {
				window.location.href = '${ctx}/sys/role/doList';
			}
		}

		function doDelInfo(id){
			submitflag = false;
			if(confirm('确定要删除该角色信息吗?')) {
				submitflag = false;
				window.location.href = '${ctx}/sys/role/doDel?id='+id;
			}
		}
	</script>
</head>
<body>
<form id="form0" action="${ctx}/sys/role/doList" method="post" >
<div class="main">
	<div class="page_title">角色管理 - 信息列表： </div>
	<div class="select">
		<div class="hang">
			<span class="tj">角色名称：<input type="text" id="roleName" name="roleName" value="${roleName}" style="width:150px;" class="input_l" /></span>
			<span class="tj">角色类别：
				<select id="roleType" name="roleType" class="input_l">
					<option value="">全部</option>
					<option value="0" <c:if test="${roleType==0}">selected</c:if>>主管部门</option>
					<option value="1" <c:if test="${roleType==1}">selected</c:if>>开发企业</option>
				</select>
			</span>
			<span class="tj">
				<input type="submit" id="doSearch" value="查询" class="a_btn_blue" />
				<input type="button" value="新增" onclick="showAddPage()" class="a_btn_blue" />
			</span>
		</div>
	</div>
	
	<div class="content">
		<table style="width:100%" class="table_list">
			<thead>
				<tr>
					<th width="40">序号</th>
					<th width="200">角色名称</th>
					<th width="150">角色类别</th>
					<th width="*">角色说明</th>
					<th width="150">操作</th>
				</tr>
			</thead>
			<c:forEach varStatus="index" items="${pageInfo.list}" var="role" >
				<tr>
					<td align="center">${index.index + 1}</td>
					<td align="left">${role.roleName}</td>
					<td align="center">
						<c:choose>
							<c:when test="${role.roleType==0}">主管部门</c:when>
							<c:when test="${role.roleType==1}">开发企业</c:when>
						</c:choose>
					</td>
					<td align="left">${role.remark}</td>
					<td align="center">
						<a href="javascript:void(0);" onclick="showEditPage(${role.id})" class="a_lan">[编辑]</a>
						<a href="javascript:void(0);" onclick="doDelInfo('${role.id}')" class="a_del">[删除]</a>
						<a href="javascript:void(0);" onclick="showViewPage(${role.id})" class="a_blue">[查看]</a>
					</td>
				</tr>
			</c:forEach>
		</table>
	</div>
	<div class="page">
		<p:pages cpage="${pageInfo.pageNum}" totalPage="${pageInfo.pages}" totalRow="${pageInfo.total}" pageSize="${pageInfo.pageSize}" form="form0" styleClass="page" theme="text"/>
	</div>
</div>
</form>
</body>
<p:message/>
</html>
